﻿using System;

namespace FactoryGetOrCreate
{
    public class Student
    {
        public int Id { get; set; }
        public String Name { get; set; }

        public override string ToString()
        {
            return string.Format("{0} {1}", Id, Name);
        }

        protected bool Equals(Student other)
        {
            return Id == other.Id;
        }

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != this.GetType()) return false;
            return Equals((Student)obj);
        }

        public override int GetHashCode()
        {
            return Id;
        }
    }
}
