﻿using FactoryGetOrCreate;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace FactoryGetOrCreateTests
{
    [TestClass]
    public class StoreTests
    {
        [TestMethod]
        public void GetTest()
        {
           Store<int, Student> store = new Store<int, Student>();
            Student st1 = store.GetOrCreate(12);
            Assert.IsNull(st1.Name);
            Assert.AreEqual(0, st1.Id);
            st1.Name = "Anders";

            Student st1B = store.GetOrCreate(12);
            Assert.AreEqual(st1, st1B);

            int id = 0;
            store.Creator = () => new Student {Id = id++};
            Student st2 = store.GetOrCreate(66);
            Assert.AreEqual(0, st2.Id);
        }
    }
}
